#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <string.h>
#include <stdlib.h>


unsigned long get_file_size(const char *path)  
{  
    unsigned long filesize = -1;      
    struct stat statbuff;  
    if(stat(path, &statbuff) < 0){  
        return filesize;  
    }else{  
        filesize = statbuff.st_size;  
    }  
    return filesize;  
}  

int main(int argc, char **argv)
{
	FILE *fp_in;
	FILE *fp_out;
	int rc;
	char bmpfile[1024] = {0};
	char path_out[1024] = {0};
	int i = 0;
	char buffer[4096];
	unsigned int length = 0;
	int pic_num = 100;
	if (argc > 3)
	{
		pic_num = atoi(argv[3]);
	}
	printf("pic_num:%d\n", pic_num);
	sprintf(path_out, "%s", argv[2]);
	printf("output:%s\n", path_out);

	fp_out = fopen(path_out, "wb+");
	if (fp_out == NULL)
	{
		printf("Open file %s error\n", bmpfile);
		return (-1);
	}
	fwrite(&pic_num, 4, 1, fp_out);
	for (i = 0; i < pic_num; i++)
	{
		sprintf(bmpfile, "%s/%d.jpg", argv[1], i + 1);
		fp_in = fopen(bmpfile, "rb");
		if (fp_in == NULL)
		{
			printf("Open file %s error\n", bmpfile);
			return (-1);
		}
		length = get_file_size(bmpfile);
		if (length < 1)
		{
			printf(" file %s error\n", bmpfile);
			return (-1);
		}
		fwrite(&length, 4, 1, fp_out);

		while (!feof(fp_in))
		{
			rc = fread(buffer, 1, 1024, fp_in);
			if (rc < 1)
				printf("file %s error\n", bmpfile);
			fwrite(buffer, 1, rc, fp_out);
		}
		fclose(fp_in);
	}
	fclose(fp_out);
	return 0;
}